stages:
  - build
  - latest

before_script:
  - docker info

build:
  image: docker:stable
  tags:
    - docker-gcc
  stage: build
  variables:
    DOCKER_HOST: tcp://docker:2375 
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: ""
  services:
    - name: docker:dind
      alias: docker
      command: ["--tls=false"]
  script: |
    echo $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER $CI_REGISTRY --password-stdin
    containers=$(cat containers)
    for c in $containers
    do
      echo "Building container: $c:${CI_COMMIT_SHORT_SHA}"
      docker build --no-cache -t registry.gitlab.com/gacybercenter/gacyberrange/cloud-imaging/container-factory/$c:${CI_COMMIT_SHORT_SHA} $c/.
      echo "Deploying Container Image: $c:${CI_COMMIT_SHORT_SHA}"
      docker push registry.gitlab.com/gacybercenter/gacyberrange/cloud-imaging/container-factory/$c:${CI_COMMIT_SHORT_SHA}
    done
  rules:
    - if: ($CI_COMMIT_MESSAGE =~ /\[build]/ || $CI_COMMIT_MESSAGE =~ /\[latest]/)

latest:
  image: docker:stable
  tags:
    - docker-gcc
  stage: latest
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: ""
  services:
    - name: docker:dind
      alias: docker
      command: ["--tls=false"]
  script: |
    echo $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER $CI_REGISTRY --password-stdin
    containers=$(cat containers)
    for c in $containers
    do
      echo "Building container: $c:latest"
      docker build --no-cache -t registry.gitlab.com/gacybercenter/gacyberrange/cloud-imaging/container-factory/$c:latest $c/.
      echo "Deploying Container Image: $c:latest"
      docker push registry.gitlab.com/gacybercenter/gacyberrange/cloud-imaging/container-factory/$c:latest
    done
  rules:
    - if: ($CI_COMMIT_MESSAGE =~ /\[latest]/ && $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH)
